
#include <stdio.h>
#include <stdlib.h>

#include <mgl.h>

void display (void)
{
  mglClearScreen (mglBlack);
  mglSetRectangleColors (mglCeleste);
  mglDrawFilledRectangle (0, 0, mglVirtualWidth, mglVirtualHeight);
}

void keyboard (int key)
{
  switch (key)
  {
    case 't':
    case 'T':
      printf ("mglTime is %02i:%02i:%02i\n", mglHours (mglTime), mglMinutes (mglTime), mglSecs (mglTime));
      printf ("mglSystemTime is %02i:%02i:%02i\n", mglHours (mglSystemTime), mglMinutes (mglSystemTime), mglSecs (mglSystemTime));
      printf ("Frames per second: %6.2f\n", mglFps);
      break;
    case 27: // Escape
      exit (0);
      break;
    default:
      if (key < 256)
        printf ("Typed character %c (ascii value %i)\n", key, key);
      else
        printf ("Pressed special key with value %i\n", key);
      if (mglShift)
        printf ("Shift key pressed.\n");
      if (mglCtrl)
        printf ("Ctrl key pressed.\n");
      if (mglAlt)
        printf ("Alt key pressed.\n");
  }
}

void mouse (int event)
{
  switch (event)
  {
    case MGL_LEFT_BUTTON_DOWN:
      printf ("Left button pressed.\n");
      break;
    case MGL_LEFT_BUTTON_UP:
      printf ("Left button released.\n");
      break;
    case MGL_RIGHT_BUTTON_DOWN:
      printf ("Right button pressed.\n");
      break;
    case MGL_RIGHT_BUTTON_UP:
      printf ("Right button released.\n");
      break;
  }
  
  if (mglMouseIn)
  {
    printf ("Mouse is located inside the window on position (%i,%i)\n", mglMouseX, mglMouseY);
  }
  else
    printf ("Mouse is not located in the window.\n");

}

int main (void)
{
  mglVirtualWidth = mglVirtualHeight = 1000;
  mglOpenWindow ("Demonstrace modulu Input", 100, 100, 256, 128);

  mglSetDisplayHandler (display);
  mglSetKeyboardHandler (keyboard);
  mglSetMouseHandler (mouse);
  mglSetMouseCursor (GLUT_CURSOR_CROSSHAIR);

  mglRun ();
  return 0;
}
