
/*
 *  alpha.c
 *  This program draws several overlapping filled polygons
 *  to demonstrate the effect order has on alpha blending results.
 *  Use the 't' key to toggle the order of drawing polygons.
 */

#include <stdlib.h>
#include <mgl.h>

int leftFirst;

void display_mgl (void)
{
  mglColor leftColor = {1.0, 1.0, 0.0, 0.75};
  mglColor rightColor = {0.0, 1.0, 1.0, 0.75};
  
  mglClearScreen (mglBlack);

 if (leftFirst)
 {
   mglSetTriangleColors (rightColor);
   mglDrawFilledTriangle (100, 100, 100, 900, 700, 500);
   mglSetTriangleColors (leftColor);
   mglDrawFilledTriangle (300, 500, 900, 900, 900, 100);
 }
 else 
 {
   mglSetTriangleColors (leftColor);
   mglDrawFilledTriangle (300, 500, 900, 900, 900, 100);
   mglSetTriangleColors (rightColor);
   mglDrawFilledTriangle (100, 100, 100, 900, 700, 500);
 }
}

void keyboard_mgl (int key)
{
  switch (key)
  {
    case 't':
    case 'T':
      leftFirst = !leftFirst;
      break;
    case 27:  /*  Escape key  */
      exit(0);
      break;
    default:
       break;
   }
}

int main (int argc, char **argv)
{
  mglVirtualWidth = mglVirtualHeight = 1000;
  mglOpenWindow (argv [0], 100, 100, 200, 200);

  mglSetKeyboardHandler (keyboard_mgl);
  mglSetDisplayHandler (display_mgl);

  mglRun ();

  return 0;
}
